rem ---------------------------------------------------------------------------
rem  Trivadis AG, Baden-Dttwil/Basel/Bern/Lausanne/Zrich
rem               Dsseldorf/Frankfurt/Freiburg i.Br./Hamburg/Mnchen/Stuttgart
rem               Wien
rem               Switzerland/Germany/Austria Internet: http://www.trivadis.com
rem ---------------------------------------------------------------------------
rem $Id: sdsynerr.sql 172 2008-11-30 16:56:30Z cha $
rem ---------------------------------------------------------------------------
rem  Group/Privileges.: DBA
rem  Script Name......: sdsynerr.sql
rem  Developer........: Ingo Frost (InF)
rem  Date.............: 01.10.2001
rem  Version..........: Oracle Database 10g
rem  Description......: Show public synonyms with an invalid reference pointing
rem                     to itself directly or nowhere (cycles are not recognized)
rem  Usage............: 
rem  Input parameters.: 
rem  Output...........: 
rem  Called by........:
rem  Requirements.....: 
rem  Remarks..........: 
rem
rem ---------------------------------------------------------------------------
rem Changes:
rem DD.MM.YYYY Developer Change
rem ---------------------------------------------------------------------------
rem 03.09.2002 ThJ       OK for Oracle9i R2
rem 09.09.2002 AnK       OK for 10.1
rem                      Changed, that only invalid synonyms are shown
rem 30.11.2008 ChA       Fixed header + Shows all "invalid" synonyms + Formatting
rem ---------------------------------------------------------------------------

set echo off
set verify off
set logsource "Dummy"
store set temp.tmp replace
clear   columns -
        breaks -
        computes
set pagesize 24 linesize 130

@@foenvtit "Synonyms without any valid reference "

col owner        format a20 heading "Synonym Owner"
col synonym_name format a30 heading "Synonym Name"
col object_owner format a20 heading "Dest-Obj Owner"
col object_name  format a30 heading "Dest-Obj Name"
col object_type  format a18 heading "Type"

select  synonym_name, owner, object_owner, object_name, object_type
from    tvd_synonyms
where   object_type in ('n/a')
order by 1,2,3,4 ;

ttitle off
prompt  Type "n/a": the synonym points to nowhere, and probably could be dropped 
prompt
@temp.tmp
